/*
 * 쐬: 2006/03/26
 *
 */
package org.seasar.coffee.script.impl;

import java.util.HashMap;
import java.util.Map;

import org.seasar.coffee.script.Script;
import org.seasar.coffee.script.ScriptFactory;

public class ScriptFactoryImpl implements ScriptFactory {
    private Map scriptMap = new HashMap();
    private Script defaultScript = null;
    private ThreadLocal context = new ThreadLocal();
    
    public Script getScript(String name) {
        return (Script)scriptMap.get(name);
    }

    public Script getDefaultScript() {
        return defaultScript;
    }

    public void addScript(String name, Script script) {
        setFastDefaultScript(script);
        scriptMap.put(name,script);
    }

    public void addScript(String name, Script script, boolean isDefault) {
        setFastDefaultScript(script);
        addScript(name, script);
        if(isDefault) {
            defaultScript = script;
        }
    }
    private void setFastDefaultScript(Script script) {
        if(defaultScript==null) {
            defaultScript = script;
        }
    }
    
    public Map getContext() {
        if(context.get()==null) {
            context.set(new HashMap());
        }
        return (Map)context.get();
    }
    
    public void setContext(Map context) {
        this.context.set(context);
    }
    
}
